/* aps 7may03  */
#include <stdlib.h>
#include <stdio.h>
#include <glut.h>  /* #include <gl\glut.h>  */
#include <sys/time.h> /* #include <sys/timeb.h>  */
#include <math.h>
#define  MAX(x,y)         (((x)<(y))?(y):(x))
#define  MIN(x,y)         (((x)<(y))?(x):(y))
#define  CLAMP(x,u,v)     (x<u? u : (x>v ? v: x))
#define  ABS(u)           ((u)<0 ? -(u): (u))
#define  FOR(a,b,c)       for((a)=(b);(a)<(c);(a)++)
#define  DOT(p,q)         ((p)[0]*(q)[0]+(p)[1]*(q)[1]+(p)[2]*(q)[2])
#define  NRM(p)           sqrt(DOT((p),(p)))
#define  DG            M_PI/180
#define  S(u)          sin(u*DG)
#define  C(u)          cos(u*DG)
#define  CLAMP(x,u,v) (x<u? u : (x>v ? v: x))
#define RND ((float)rand()/RAND_MAX)         /* random fraction */
#define IFCLICK(K,a){static ff=1; if(getbutton(K))ff=1-ff; if(ff){a} }

#define MANY 1048576 
#define NN   10     /* 4^10 = 1048576  */
float AA[MANY][2];  /* buffer for 4^10 points */ 
float aa[4]={0., .85, .2, -.15};
float bb[4]={0., .04, -.26, .28};
float cc[4]={0., -.04, .23, .26};
float dd[4]={.16, .85, .22, .24};
float ee[4]={0., 0., 0., 0.};
float ff[4]={0., .16, .16, .044};
int mm=0;
/***********************************************************/
void loadA(void){ int kk;   /* with random fractional coords*/
FOR(kk,0,MANY){AA[kk][0]=RND; AA[kk][1]=RND;} 
}
/***********************************************************/
void zeroA(void){ int kk;   /* with random fractional coords*/
FOR(kk,0,MANY){AA[kk][0]=AA[kk][1]=0;} 
}
/***********************************************************/
void testdisplay(){ int kk;
  FOR(kk,0,MANY){  
      glBegin(GL_POINTS);                 /* draw a */
        glColor3f(1.0,1.0,1.0);
        glVertex2fv(AA[kk]);                  /* point  */
      glEnd();
  }
}
/***********************************************************/
void display(){  int uu,kk,top;

  
  FOR(uu,0,NN){ top = (int)pow(4,uu);   /* top of stack */
  FOR(kk,0,top){
  AA[top + 3*kk][0]  = aa[1]*AA[kk][0]+bb[1]*AA[kk][1]+ee[1];
  AA[top + 3*kk][1]  = cc[1]*AA[kk][0]+dd[1]*AA[kk][1]+ff[1];
  AA[top + 3*kk+1][0]= aa[2]*AA[kk][0]+bb[2]*AA[kk][1]+ee[2];
  AA[top + 3*kk+1][1]= cc[2]*AA[kk][0]+dd[2]*AA[kk][1]+ff[2];
  AA[top + 3*kk+2][0]= aa[3]*AA[kk][0]+bb[3]*AA[kk][1]+ee[3];
  AA[top + 3*kk+2][1]= cc[3]*AA[kk][0]+dd[3]*AA[kk][1]+ff[3];
  AA[kk][0]          = aa[0]*AA[kk][0]+bb[0]*AA[kk][1]+ee[0];
  AA[kk][1]          = cc[0]*AA[kk][0]+dd[0]*AA[kk][1]+ff[0];
      glBegin(GL_POINTS);
        glColor3f(1.0,1.0,1.0);
        glVertex2fv(AA[kk]);
        glVertex2fv(AA[top+3*kk]);
        glVertex2fv(AA[top+3*kk+1]);
        glVertex2fv(AA[top+3*kk+2]);
      glEnd();
  }}
 
  if (mm<10) {
    aa[0]+=.05; aa[1]-=.035; aa[2]+=.03; aa[3]+=.015;
    bb[0]+=0.; bb[1]-=.004; bb[2]+=.026; bb[3]-=.028;
    cc[0]+=0.; cc[1]+=.004; cc[2]-=.023; cc[3]-=.026;
    dd[0]+=.034; dd[1]-=.035; dd[2]+=.028; dd[3]-=.024;
    ee[0]+=0.; ee[1]+=0.; ee[2]+=.05; ee[3]+=0.;
    ff[0]+=0.; ff[1]+=.034; ff[2]+=.034; ff[3]-=.0044;


    glClear(GL_COLOR_BUFFER_BIT);
  }
  mm++;

}
/***********************************************************/
void keyboard(unsigned char key, int x, int y){
  switch(key){ 
     case  27: exit(0); break;        /* escape with the  (ESC) key  */ 
     case 'w': glClear(GL_COLOR_BUFFER_BIT); break; /* (W)ipe screen */
   }
}
/***********************************************************/
void idle(void){ glutPostRedisplay(); } 
/***********************************************************/
int main(int argc, char **argv){  /* pure GLUTtery here */ 
  /* loadA(); */
  zeroA();
  glutInitWindowSize(400, 400);        
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB); 
  glutCreateWindow("<< Barnsley's Fern in GLUT >>");
  glutDisplayFunc(display);
  glutKeyboardFunc(keyboard);
  glutIdleFunc(idle); 
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-1,1,0,1.,1.,-1.);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}
